#include <bits/stdc++.h>

using namespace std;

#define int long long

void dfs(int start, vector<vector<int>>& a, vector<bool>& visited, int range) {

    visited[start] = true;

    if (range == 0) {
        return;
    }

    for (int neighbor : a[start]) {
        if (!visited[neighbor]) {
            dfs(neighbor, a, visited, range - 1);
        }
    }
}

signed main() {
    int n, m, k; 
    cin >> n >> m >> k;

    if (k == 0) {
        cout << 0;
        return 0;
    }

    vector<vector<int>> a(n);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        a[u].push_back(v);
        a[v].push_back(u);
    }

    vector<int> protecte(k);
    vector<int> range(k);

    for (int i = 0; i < k; i++) {
        cin >> protecte[i];
        cin >> range[i];
        protecte[i]--;
    }

    vector<bool> visited(n, false);
    vector<bool> total_visited(n, false);

    for (int i = 0; i < k; i++) {
        fill(visited.begin(), visited.end(), false);
        dfs(protecte[i], a, visited, range[i]);

        for (int j = 0; j < n; j++) {
            if (visited[j]) {
                total_visited[j] = true;
            }
        }
    }

    int count = 0;

    for (int i = 0; i < n; i++) {
        if (total_visited[i]) {
            count++;
        }
    }

    cout << count << endl;

    for (int i = 0; i < n; i++) {
        if (total_visited[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;

    return 0;
}