#include <bits/stdc++.h>

using namespace std;

#define int long long

void dfs(int start, vector<vector<int>>& a, vector<bool>& visited, int range) {

    visited[start] = true;

    if (range == 0) {
        return;
    }

    for (int i = 0; i < a.size(); i++) {
        if (a[i][0] == start && !visited[a[i][1]]) {
            dfs(a[i][1], a, visited, range - 1);
        }
        if (a[i][1] == start && !visited[a[i][0]]) {
            dfs(a[i][0], a, visited, range - 1);
        }
    }
}

signed main() {
    int n, m, k; 
    cin >> n >> m >> k;

    if (k == 0) {
        return 0;
    }

    vector<vector<int>> a(m, vector<int>(2));

    for (int i = 0; i < m; i++) {
        cin >> a[i][0];
        cin >> a[i][1];
        a[i][0]--;
        a[i][1]--;
    }

    vector<int> protecte(k);
    vector<int> range(k);

    for (int i = 0; i < k; i++) {
        cin >> protecte[i];
        cin >> range[i];
        protecte[i]--;
    }

    vector<bool> visited(n, false);

    for (int i = 0; i < k; i++) {
        dfs(protecte[i], a, visited, range[i]);
    }

    int count = 0;

    for (int i = 0; i < n; i++) {
        if (visited[i]) {
            count++;
        }
    }

    cout << count << endl;

    for (int i = 0; i < n; i++) {
        if (visited[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;

    return 0;
}